diff -r f77229934d59 src/org/armedbear/lisp/Pathname.java
--- a/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:34:38 2010 +0100
@@ -1237,154 +1407,445 @@
             LispObject[] array = result.copyToArray();
             for (int i = 0; i < array.length - 1; i++) {
                 if (array[i] == Keyword.BACK) {
-                    if (array[i+1] instanceof AbstractString || array[i+1] == Keyword.WILD) {
+                    if (array[i + 1] instanceof AbstractString || array[i + 1] == Keyword.WILD) {
                         array[i] = null;
-                        array[i+1] = null;
+                        array[i + 1] = null;
                     }
                 }
             }
             result = NIL;
             for (int i = 0; i < array.length; i++) {
-                if (array[i] != null)
+                if (array[i] != null) {
                     result = new Cons(array[i], result);
+                }
             }
             return result;
         }
         return dir;
     }
 
-    public static final LispObject truename(LispObject arg,
-                                            boolean errorIfDoesNotExist)
+    public static final LispObject truename(Pathname pathname) {
+        return truename(pathname, false);
+    }
 
+    public static final LispObject truename(LispObject arg) {
+        return truename(arg, false);
+    }
+
+    public static final LispObject truename(LispObject arg, boolean errorIfDoesNotExist) {
+        final Pathname pathname = coerceToPathname(arg);
+        return truename(pathname, errorIfDoesNotExist);
+    }
+
+    /** @return The canonical TRUENAME as a Pathname if the pathname
+     * exists, otherwise returns NIL or possibly a subtype of
+     * LispError if there are logical problems with the input.
+     */
+    public static final LispObject truename(Pathname pathname,
+                                            boolean errorIfDoesNotExist) 
     {
-        Pathname pathname = coerceToPathname(arg);
-        if (pathname instanceof LogicalPathname)
-            pathname = LogicalPathname.translateLogicalPathname((LogicalPathname)pathname);
-        if (pathname.isWild())
+        if (pathname instanceof LogicalPathname) {
+            pathname = LogicalPathname.translateLogicalPathname((LogicalPathname) pathname);
+        }
+        if (pathname.isWild()) {
             return error(new FileError("Bad place for a wild pathname.",
-                                       pathname));
-        final Pathname defaultedPathname =
-            mergePathnames(pathname,
-                           coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue()),
-                           NIL);
-        final String namestring = defaultedPathname.getNamestring();
-        if (namestring == null)
-            return error(new FileError("Pathname has no namestring: " + defaultedPathname.writeToString(),
-                                       defaultedPathname));
-        final File file = new File(namestring);
-        if (file.isDirectory())
-            return Utilities.getDirectoryPathname(file);
-        if (file.exists()) {
-            try {
-                return new Pathname(file.getCanonicalPath());
+              pathname));
+        }
+        if (!(pathname.device instanceof Cons)) {
+            pathname
+                = mergePathnames(pathname,
+                                 coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue()),
+                                 NIL);
+            final String namestring = pathname.getNamestring();
+            if (namestring == null) {
+                return error(new FileError("Pathname has no namestring: " 
+                                           + pathname.writeToString(),
+                                           pathname));
             }
-            catch (IOException e) {
-                return error(new LispError(e.getMessage()));
+            
+            final File file = new File(namestring);
+            if (file.isDirectory()) {
+                return Utilities.getDirectoryPathname(file);
+            }
+            if (file.exists()) {
+                try {
+                    return new Pathname(file.getCanonicalPath());
+                } catch (IOException e) {
+                    return error(new FileError(e.getMessage(), pathname));
+                }
+            }
+        } else
+        jarfile: {
+            // Possibly canonicalize jar file directory
+            Cons jars = (Cons) pathname.device;
+            LispObject o = jars.car();
+            if (o instanceof Pathname) {
+                LispObject truename = Pathname.truename((Pathname)o, errorIfDoesNotExist);
+                if (truename != null
+                    && truename instanceof Pathname) {
+                    jars.car = (Pathname)truename;
+                } else {
+                    break jarfile;
+                }
+            }
+
+            // Check for existence of a JAR file and/or JarEntry
+            //
+            // Cases:
+            // 1.  JAR
+            // 2.  JAR in JAR
+            // 3.  JAR with Entry
+            // 4.  JAR in JAR with Entry
+            JarFile jarFile = getJarFile(jars.car());
+            String entryPath = pathname.asEntryPath();
+            if (jarFile != null) {
+                if (jars.cdr() instanceof Cons) {
+                  Pathname inner = (Pathname) jars.cdr().car();
+                  InputStream inputStream = Utilities.getInputStream(jarFile, inner);
+                  if (inputStream != null) {
+                      if (entryPath.length() == 0) {
+                          return pathname; // Case 2
+                      } else {
+                          ZipInputStream zipInputStream
+                              = new ZipInputStream(inputStream);
+                          ZipEntry entry = Utilities.getEntry(zipInputStream,
+                                                              entryPath,
+                                                              false);
+                          if (entry != null) {
+                              // XXX this could possibly be a directory?
+                              return pathname; // Case 4
+                         }
+                      }
+                  }
+                } else {
+                    if (entryPath.length() == 0) {
+                        return pathname; // Case 1
+                    } else {
+                        ZipEntry entry = jarFile.getEntry(entryPath);
+                        if (entry != null) {
+                            // ensure this isn't a directory
+                            try {
+                                InputStream input = jarFile.getInputStream(entry);
+                                if (input != null) {
+                                    return pathname; // Case 3
+                                }
+                            } catch (IOException e) {
+                                break jarfile;
+                            }
+                        }
+                    }
+                }
             }
         }
+        error:
         if (errorIfDoesNotExist) {
             FastStringBuffer sb = new FastStringBuffer("The file ");
-            sb.append(defaultedPathname.writeToString());
+            sb.append(pathname.writeToString());
             sb.append(" does not exist.");
-            return error(new FileError(sb.toString(), defaultedPathname));
+            return error(new FileError(sb.toString(), pathname));
         }
         return NIL;
     }
 
+    private static URL getJarURL(Pathname p) {
+        String jarURL = "jar:file:" + p.getNamestring() + "!/";
+        URL result = null;
+        try {
+            result = new URL(jarURL);
+        } catch (MalformedURLException ex) {
+            // XXX
+            Debug.trace("Could not form URL from pathname "
+              + "'" + jarURL + "'"
+              + " because " + ex);
+        }
+        return result;
+    }
+
+    private static URL getJarURL(String url) {
+        String jarURL = "jar:" + url + "!/";
+        URL result = null;
+        try {
+            result = new URL(jarURL);
+        } catch (MalformedURLException ex) {
+            // XXX
+            Debug.trace("Could not form jar URL from  "
+              + "'" + jarURL + "'"
+              + " because " + ex);
+        }
+        return result;
+    }
+  
+    private static JarFile getJarFile(LispObject device) {
+        URL url = null;
+        if (device instanceof SimpleString) {
+            url = getJarURL(((SimpleString) device).getStringValue());
+        } else {
+            url = getJarURL((Pathname) device);
+        }
+        if (url == null) {
+            return null;
+        }
+        URLConnection connection;
+        try {
+            connection = url.openConnection();
+        } catch (IOException ex) {
+            Debug.trace("Failed to open "
+              + "'" + url + "'");
+            return null;
+        }
+        if (!(connection instanceof JarURLConnection)) {
+            // XXX
+            Debug.trace("Could not get a URLConnection from " + url);
+            return null;
+        }
+        JarURLConnection jarURLConnection = (JarURLConnection) connection;
+
+        JarFile result;
+        try {
+            result = jarURLConnection.getJarFile();
+        } catch (IOException ex) {
+            Debug.trace("Could not get a JarURLConnection from "
+              + "'" + jarURLConnection + "'");
+            return null;
+        }
+        return result;
+    }
+
+    public InputStream getInputStream() {
+        InputStream result = null;
+        if (isJar()) {
+            String entryPath = asEntryPath();
+            // XXX We only return the bytes of an entry in a JAR
+            Debug.assertTrue(entryPath != null);
+            JarFile jarFile = Pathname.getJarFile(device.car());
+            Debug.assertTrue(jarFile != null);
+            // Is this a JAR within a JAR?
+            if (device.cdr() instanceof Cons) {
+                Pathname inner = (Pathname) device.cdr().car();
+                InputStream input = Utilities.getInputStream(jarFile, inner);
+                ZipInputStream zipInputStream = new ZipInputStream(input);
+                result =  Utilities.getEntryAsInputStream(zipInputStream, entryPath);
+            } else {
+                ZipEntry entry = jarFile.getEntry(entryPath);
+		if (entry == null) {
+		    Debug.trace("Failed to get InputStream for "    
+				+ "'" + getNamestring() + "'");
+
+		    Debug.assertTrue(false);
+		}
+                try {
+                    result = jarFile.getInputStream(entry);
+                } catch (IOException e) {
+                    Debug.trace("Failed to get InputStream from "
+                                + "'" + getNamestring() + "'"
+                                + ": " + e);
+                }
+            }
+        } else {
+            File file = Utilities.getFile(this);
+            try { 
+                result = new FileInputStream(file);
+            } catch (IOException e) {
+                Debug.trace("Failed to get InputStream for read from "
+                                + "'" + getNamestring() + "'"
+                                + ": " + e);
+            }
+        }
+        return result;
+    }
+
+    // ### last-modified pathname => time-in-milliseconds
+    public static final Primitive LAST_MODIFIED
+        = new Primitive("LAST-MODIFIED", PACKAGE_EXT, true, "pathname", 
+                        "If PATHNAME exists, returns the last modified time in miliseconds since the UNIX epoch.")  
+            {
+                @Override
+                public LispObject execute(LispObject arg) {
+                    final Pathname p = coerceToPathname(arg);
+                    if (p.isWild()) {
+                        error(new FileError("Bad place for a wild pathname.", p));
+                    }
+                    long time = Pathname.getLastModified(p);
+                    return LispInteger.getInstance(time);
+                }
+            };
+
+    /** @return Time in milliseconds since the UNIX epoch at which the
+     * resource was last modified, or 0 if the time is unknown.
+     */
+    protected static long getLastModified(Pathname p) {
+        if (!(p.device instanceof Cons)) {
+            File f = new File(p.getNamestring());
+            return f.lastModified();
+        }
+        // JAR cases
+        // 0.  JAR from URL 
+        // 1.  JAR
+        // 2.  JAR in JAR
+        // 3.  Entry in JAR
+        // 4.  Entry in JAR in JAR
+        String entryPath = p.asEntryPath();
+        Cons device = (Cons)p.device;
+        if (device.cdr().equals(NIL)) {
+            if (entryPath.length() == 0) {
+                LispObject o = device.car();
+                if (o instanceof SimpleString) {
+                    // 0. JAR from URL
+                    URL u = getJarURL(o.getStringValue());
+                    URLConnection c = null;
+                    try {
+                      c = u.openConnection();
+                    } catch(IOException e) {
+                      Debug.trace("Failed to open Connection for URL "
+                                  + "'" + u + "'");
+                      return 0;
+                    }
+                    c.getLastModified();
+                } else  {  
+                    // 1. JAR
+                    return Pathname.getLastModified((Pathname)o);
+                }
+            } else {
+                // 3. Entry in JAR
+                final JarEntry entry = getJarFile(device.car()).getJarEntry(entryPath);
+                final long time = entry.getTime();
+                if (time == -1) {
+                    return 0;
+                }
+                return time;
+            }
+        } else {
+            JarFile outerJar = getJarFile(device.car());
+            if (entryPath.length() == 0) {
+                // 4.  JAR in JAR
+                String jarPath = ((Pathname)device.cdr()).asEntryPath();
+                final JarEntry entry = outerJar.getJarEntry(jarPath);
+                final long time = entry.getTime();
+                if (time == -1) {
+                    return 0;
+                }
+                return time;
+            } else {
+                // 5. Entry in JAR in JAR
+                String innerJarPath = ((Pathname)device.cdr()).asEntryPath();
+                ZipEntry entry = outerJar.getEntry(entryPath);
+                ZipInputStream innerJarInputStream
+                    = Utilities.getZipInputStream(outerJar, innerJarPath);
+                ZipEntry innerEntry = Utilities.getEntry(innerJarInputStream,
+                                                         entryPath);
+                long time = innerEntry.getTime();
+                if (time == -1) {
+                    return 0;
+                }
+                return time;
+            }
+        }
+        return 0;
+    }
+
     // ### mkdir
     private static final Primitive MKDIR =
-        new Primitive("mkdir", PACKAGE_SYS, false)
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            final Pathname pathname = coerceToPathname(arg);
-            if (pathname.isWild())
-                error(new FileError("Bad place for a wild pathname.", pathname));
-            Pathname defaultedPathname =
+      new Primitive("mkdir", PACKAGE_SYS, false) {
+
+          @Override
+          public LispObject execute(LispObject arg) {
+              final Pathname pathname = coerceToPathname(arg);
+              if (pathname.isWild()) {
+                  error(new FileError("Bad place for a wild pathname.", pathname));
+              }
+              Pathname defaultedPathname =
                 mergePathnames(pathname,
-                               coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue()),
-                               NIL);
-            File file = Utilities.getFile(defaultedPathname);
-            return file.mkdir() ? T : NIL;
-        }
-    };
-
+                coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue()),
+                NIL);
+              File file = Utilities.getFile(defaultedPathname);
+              return file.mkdir() ? T : NIL;
+          }
+      };
     // ### rename-file filespec new-name => defaulted-new-name, old-truename, new-truename
     public static final Primitive RENAME_FILE =
-        new Primitive("rename-file", "filespec new-name")
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("rename-file", "filespec new-name") {
 
-        {
-            final Pathname original = (Pathname) truename(first, true);
-            final String originalNamestring = original.getNamestring();
-            Pathname newName = coerceToPathname(second);
-            if (newName.isWild())
-                error(new FileError("Bad place for a wild pathname.", newName));
-            newName = mergePathnames(newName, original, NIL);
-            final String newNamestring;
-            if (newName instanceof LogicalPathname)
-                newNamestring = LogicalPathname.translateLogicalPathname((LogicalPathname)newName).getNamestring();
-            else
-                newNamestring = newName.getNamestring();
-            if (originalNamestring != null && newNamestring != null) {
-                final File source = new File(originalNamestring);
-                final File destination = new File(newNamestring);
-                if (Utilities.isPlatformWindows) {
-                    if (destination.isFile())
-                        destination.delete();
-                }
-                if (source.renameTo(destination))
-                    // Success!
-                    return LispThread.currentThread().setValues(newName, original,
-                                                                truename(newName, true));
-            }
-            return error(new FileError("Unable to rename " +
-                                       original.writeToString() +
-                                       " to " + newName.writeToString() +
-                                       "."));
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              final Pathname original = (Pathname) truename(first, true);
+              final String originalNamestring = original.getNamestring();
+              Pathname newName = coerceToPathname(second);
+              if (newName.isWild()) {
+                  error(new FileError("Bad place for a wild pathname.", newName));
+              }
+              newName = mergePathnames(newName, original, NIL);
+              final String newNamestring;
+              if (newName instanceof LogicalPathname) {
+                  newNamestring = LogicalPathname.translateLogicalPathname((LogicalPathname) newName).getNamestring();
+              } else {
+                  newNamestring = newName.getNamestring();
+              }
+              if (originalNamestring != null && newNamestring != null) {
+                  final File source = new File(originalNamestring);
+                  final File destination = new File(newNamestring);
+                  if (Utilities.isPlatformWindows) {
+                      if (destination.isFile()) {
+                          destination.delete();
+                      }
+                  }
+                  if (source.renameTo(destination)) // Success!
+                  {
+                      return LispThread.currentThread().setValues(newName, original,
+                        truename(newName, true));
+                  }
+              }
+              return error(new FileError("Unable to rename "
+                + original.writeToString()
+                + " to " + newName.writeToString()
+                + "."));
+          }
+      };
     // ### file-namestring pathname => namestring
     private static final Primitive FILE_NAMESTRING =
-        new Primitive("file-namestring", "pathname")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            Pathname p = coerceToPathname(arg);
-            FastStringBuffer sb = new FastStringBuffer();
-            if (p.name instanceof AbstractString)
-                sb.append(p.name.getStringValue());
-            else if (p.name == Keyword.WILD)
-                sb.append('*');
-            else
-                return NIL;
-            if (p.type instanceof AbstractString) {
-                sb.append('.');
-                sb.append(p.type.getStringValue());
-            } else if (p.type == Keyword.WILD)
-                sb.append(".*");
-            return new SimpleString(sb);
-        }
-    };
+      new Primitive("file-namestring", "pathname") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              Pathname p = coerceToPathname(arg);
+              FastStringBuffer sb = new FastStringBuffer();
+              if (p.name instanceof AbstractString) {
+                  sb.append(p.name.getStringValue());
+              } else if (p.name == Keyword.WILD) {
+                  sb.append('*');
+              } else {
+                  return NIL;
+              }
+              if (p.type instanceof AbstractString) {
+                  sb.append('.');
+                  sb.append(p.type.getStringValue());
+              } else if (p.type == Keyword.WILD) {
+                  sb.append(".*");
+              }
+              return new SimpleString(sb);
+          }
+      };
     // ### host-namestring pathname => namestring
     private static final Primitive HOST_NAMESTRING =
-        new Primitive("host-namestring", "pathname")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return coerceToPathname(arg).host;
-        }
-    };
+      new Primitive("host-namestring", "pathname") {
+
+          @Override
+          public LispObject execute(LispObject arg) {
+              return coerceToPathname(arg).host;
+          }
+      };
+    
+    public String toString() {
+        return getNamestring();
+    }
 
     static {
         LispObject obj = Symbol.DEFAULT_PATHNAME_DEFAULTS.getSymbolValue();
         Symbol.DEFAULT_PATHNAME_DEFAULTS.setSymbolValue(coerceToPathname(obj));
     }
+
+    
 }
+// Local Variables:
+// c-basic-offset: 4
+// End:
+
diff -r f77229934d59 src/org/armedbear/lisp/Site.java
--- a/src/org/armedbear/lisp/Site.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Site.java	Tue Jan 26 12:34:38 2010 +0100
@@ -42,40 +42,36 @@
 
 public final class Site
 {
-    private static final String LISP_HOME;
+    private static Pathname LISP_HOME;
 
-    static {
-        String lispHome = System.getProperty("abcl.home");
-        if (lispHome == null) {
-            URL url = Lisp.class.getResource("boot.lisp");
-            if (url != null) {
-                String protocol = url.getProtocol();
-                if (protocol != null && protocol.equals("file")) {
-                    String path = url.getPath();
-                    try {
-                        path = URLDecoder.decode(path, "UTF-8");
-                    }
-                    catch (java.io.UnsupportedEncodingException uee) {
-                        // can't happen: Java implementations are required to
-                        // support UTF-8
-                    }
-                    int index = path.lastIndexOf('/');
-                    if (index >= 0) {
-                        lispHome = path.substring(0, index + 1);
-                        if (Utilities.isPlatformWindows) {
-                            if (lispHome.length() > 0 && lispHome.charAt(0) == '/')
-                                lispHome = lispHome.substring(1);
-                        }
-                    }
-                }
+    private static void init() {
+        String s = System.getProperty("abcl.home");
+        if (s != null) {
+            String fileSeparator = System.getProperty("file.separator");
+            if (!s.endsWith(fileSeparator)) {
+                s += fileSeparator;;
             }
+            LISP_HOME = new Pathname(s);
+            return;
         }
-        LISP_HOME = lispHome;
+        URL url = Lisp.class.getResource("boot.lisp");
+        if (url != null) {
+            LISP_HOME = new Pathname(url);
+            LISP_HOME.name = NIL;
+            LISP_HOME.type = NIL;
+            LISP_HOME.invalidateNamestring();
+            return;
+        }
+        Debug.trace("Unable to determine LISP_HOME.");
     }
 
-    public static final String getLispHome()
+
+    public static final Pathname getLispHome()
     {
-        return LISP_HOME;
+      if (LISP_HOME == null) {
+        init();
+      }
+      return LISP_HOME;
     }
 
     // ### *lisp-home*
@@ -83,8 +79,12 @@
         exportSpecial("*LISP-HOME*", PACKAGE_EXT, NIL);
 
     static {
-        String s = Site.getLispHome();
-        if (s != null)
-            _LISP_HOME_.setSymbolValue(new Pathname(s));
+        Pathname p  = Site.getLispHome();
+        if (p != null)
+            _LISP_HOME_.setSymbolValue(p);
     }
 }
+
+// Local Variables:
+// c-basic-offset: 4
+// End:
diff -r f77229934d59 src/org/armedbear/lisp/Stream.java
--- a/src/org/armedbear/lisp/Stream.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Stream.java	Tue Jan 26 12:34:38 2010 +0100
@@ -394,7 +394,7 @@
 
     {
         LispObject result = readPreservingWhitespace(eofError, eofValue,
-                            recursive, thread);
+                                                     recursive, thread);
         if (result != eofValue && !recursive) {
             try {
                 if (_charReady()) {
@@ -422,9 +422,9 @@
         internSpecial("*SHARP-EQUAL-ALIST*", PACKAGE_SYS, NIL);
 
     public LispObject readPreservingWhitespace(boolean eofError,
-            LispObject eofValue,
-            boolean recursive,
-            LispThread thread)
+                                               LispObject eofValue,
+                                               boolean recursive,
+                                               LispThread thread)
 
     {
         if (recursive) {
@@ -434,6 +434,7 @@
                 try {
                     n = _readChar();
                 } catch (IOException e) {
+                    Debug.trace(e);
                     error(new StreamError(this, e));
                 }
                 if (n < 0) {
@@ -2557,3 +2558,6 @@
         }
     };
 }
+// Local Variables:
+// c-basic-offset: 4
+// End:
diff -r f77229934d59 src/org/armedbear/lisp/Symbol.java
--- a/src/org/armedbear/lisp/Symbol.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Symbol.java	Tue Jan 26 12:34:38 2010 +0100
@@ -2909,6 +2909,8 @@
     PACKAGE_EXT.addExternalSymbol("GETENV");
   public static final Symbol MACROEXPAND_ALL =
     PACKAGE_EXT.addExternalSymbol("MACROEXPAND-ALL");
+  public static final Symbol LOAD_TRUENAME_FASL =
+    PACKAGE_EXT.addExternalSymbol("*LOAD-TRUENAME-FASL*");
 
   // MOP.
   public static final Symbol STANDARD_READER_METHOD =
